<?php
defined('BASEPATH') or exit('No direct script access allowed');

class Cron extends CI_Controller
{

    public function add_daily_growth_new()
    {

        $this->load->model('Adm');
        $this->load->model('Members');

        $rows = $this->Members->get_all_rows_wallet();

        if ($rows) {
            foreach ($rows as $row) {
                $team = $this->Members->getMyTeam($row['user_id']);
                $teamMember = $team ? count($team) : 0;
                // if($teamMember == 0){
                //     $growth = 2;
                // }else{
                //     $growth = 2+$teamMember;
                // }

                $growth = 0.166;
                $percentage = $growth / 100;

                $userId = $row['user_id'];
                $amount =    $row['wallet_amount'] * $percentage;


                $lastRow = $this->Adm->get_daily_growth_by_userid($userId);

                $balance = MemberHelper::user_wallet($userId);

                $data['user_id'] = $userId;
                $data['amount'] = $amount;
                $data['before_amount'] = $balance ? $balance : 0;
                $data['after_amount'] = $balance ? $balance + $amount : $amount;
                $data['day'] = $lastRow ? $lastRow['day'] + 1 : 1;
                $data['created_at'] = date("Y-m-d H:i:s");
                $res = $this->Adm->daily_growth($data);
                if ($res) {

                    $wallet['user_id'] = $userId;
                    $wallet['wallet_amount'] = $amount;
                    $wallet['updated_at'] = date("Y-m-d");
                    $this->Members->add_wallet_amount($userId, $wallet);
                }
            }
        }
    }


    function coinpaymentWebhook()
    {

        $merchant_id = "b5b4992ca04a48a74ccf4c34323249a3";

        $ipn_secret = "gfhj867545##5$$@";

        $debug_email = "snannaveed12@gmail.com";



        $txn_id = $_POST['txn_id'];

        $payment = $this->Members->getCoinPaymentByTxn($txn_id);

        $order_currency = $payment['to_currency']; //BTC

        $order_total = $payment['amount_in_btc']; //BTC

        if (!isset($_POST['ipn_mode']) || $_POST['ipn_mode'] != 'hmac') {

            $this->edie("IPN Mode is not HMAC");
        }



        if (!isset($_SERVER['HTTP_HMAC']) || empty($_SERVER['HTTP_HMAC'])) {

            $this->edie("No HMAC Signature Sent.");
        }



        $request = file_get_contents('php://input');

        // return $request;

        if ($request === false || empty($request)) {

            $this->edie("Error in reading Post Data");
        }



        if (!isset($_POST['merchant']) || $_POST['merchant'] != trim($merchant_id)) {

            $this->edie("No or incorrect merchant id.");
        }



        $hmac =  hash_hmac("sha512", $request, trim($ipn_secret));

        if (!hash_equals($hmac, $_SERVER['HTTP_HMAC'])) {

            $this->edie("HMAC signature does not match.");
        }



        $amount1 = floatval($_POST['amount1']); //IN USD

        $amount2 = floatval($_POST['amount2']); //IN BTC

        $currency1 = $_POST['currency1']; //USD

        $currency2 = $_POST['currency2']; //BTC

        $status = intval($_POST['status']);



        if ($currency2 != $order_currency) {

            $this->edie("Currency Mismatch");
        }



        if ($amount2 < $order_total) {

            $this->edie("Amount is lesser than order total");
        }



        if ($status >= 100 || $status == 2) {

            // Payment is complete

            $this->Members->updateCoinPayment($payment['id'], ['status' => 'success']);

            $this->addFunds($payment['user_id'], $payment['amount_in_usd']);
        } else if ($status < 0) {

            // Payment Error

            $this->Members->updateCoinPayment($payment['id'], ['status' => 'error']);
        } else {

            // Payment Pending

            $this->Members->updateCoinPayment($payment['id'], ['status' => 'pending']);
        }

        die("IPN OK");
    }

    function edie($error_msg)
    {

        global $debug_email;

        $report =  "ERROR : " . $error_msg . "\n\n";

        $report .= "POST DATA\n\n";

        foreach ($_POST as $key => $value) {

            $report .= "|$key| = |$value| \n";
        }

        $cpIPN = ['report' => $report, 'created_at' => Helpers::date()];

        $this->Members->saveCoinPaymentIPN($cpIPN);
    }



    // function test()
    // {

    //     $this->addFunds(2, 20.5);
    // }

    function addFunds($userId, $amount)
    {

        $wallet = array();

        $wallet['user_id'] = $userId;

        $wallet['wallet_amount'] = $amount;

        $wallet['updated_at'] = Helpers::date();

        $result = $this->Members->add_wallet_amount($userId, $wallet);

        // if ($result) {

        //     $userObj = Helpers::getUserObj($userId);

        //     // $message = "Hi! " . $userObj['full_name'] . ". We have added $" . $amount . " to your wallet";

        //     // Helpers::SendEmail("Funds Added", $userObj["email"], $message);
        // }
    }
}
