$(document).ready(function() {
    // Smooth scrolling for anchor links
    $("a").on('click', function(event) {
        if (this.hash !== "") {
            event.preventDefault();
            var hash = this.hash;
            $('html, body').animate({
                scrollTop: $(hash).offset().top
            }, 800, function() {
                window.location.hash = hash;
            });
        }
    });

    // Close mobile menu on nav item click
    $('.nav-item, .single').click(function() {
        $('.bsnav-mobile').removeClass('in');
    });

    // Initialize slider and result calculations
    var slider1 = document.getElementById("slide1");
    var output1 = document.getElementById("rangeValue1");
    var slider = document.getElementById("slide");
    var output = document.getElementById("rangeValue");
    
    $(output).val(64500);
    $(slider).val(64500);
    $(output1).val("1 month");
    $(slider1).val(1);

    // Function to update slider output and result based on daily return rate
    function updateResult() {
        var amount = parseFloat($("#rangeValue").val());
        var time = parseInt($("#slide1").val());
        var interval = $("#intervalSelect").val();
        var resultId = $("#result-return");

        var dailyRate = 1.0033; // 0.33% daily

        if (interval === "Monthly") {
            amount *= Math.pow(dailyRate, time * 30);
        } else {
            amount *= Math.pow(dailyRate, time * 365);
        }

        var resultAmount = amount.toFixed(2);
        resultId.html("$" + resultAmount);
    }

    // Update slider1 output text and result on input change
    slider1.addEventListener('input', function() {
        var value = parseInt(slider1.value);
        output1.value = value > 1 ? value + " months" : "1 month";
        updateResult();
    });

    // Update slider output and result on input change
    slider.addEventListener('input', function() {
        output.value = slider.value;
        updateResult();
    });

    // Interval select change event
    $("#intervalSelect").change(function() {
        var interval = $(this).val();
        if (interval === "Monthly") {
            $("#timeUnit").text("Months");
            $("#slide1").attr("max", "12");
        } else {
            $("#timeUnit").text("Years");
            $("#slide1").attr("max", "10");
        }
        updateResult();
    });

    // Initial calculation on page load
    updateResult();
});
